#pragma once

#include "WinCore.h"

//////////////////////////////////////////////////////////////////////////
// CDemoApp
//////////////////////////////////////////////////////////////////////////
class CDemoApp : public CWinApp
{
public:
	CDemoApp();
	~CDemoApp();

protected:
	bool	InitInstance();
};

//////////////////////////////////////////////////////////////////////////
// CDemoWnd
//////////////////////////////////////////////////////////////////////////
class CDemoWnd : public CWinWnd
{
protected:
	struct TMSGMAP {
		typedef LRESULT (CDemoWnd::*MSGPROC)(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);

		UINT		m_nMsg;
		MSGPROC		m_MsgProc;
	};

public: 
	CDemoWnd();
	~CDemoWnd();

protected:
	LRESULT		WndProc(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);

protected:
	LRESULT		OnCreate(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);
	LRESULT		OnDestroy(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);
	LRESULT		OnPaint(HWND hWnd, UINT nMsg, WPARAM wParam, LPARAM lParam);

private:
	void		PartitionGrid(HDC hDC, RECT* prtGrids, int nGridCount);

	void		DemoSolidBrush(HDC hDC, RECT& rtGrid);

	void		DemoPatternBrush(HDC hDC, RECT& rtGrid);

	void		DemoHatchBrush(HDC hDC, RECT& rtGrid);

	void		DemoKindOfBrush(HDC hDC, RECT& rtGrid);

private:
	static const TMSGMAP MsgMapTable[];
};
